controllers/EtapaController.php
<?php

namespace app\controllers;

use app\models\Etapa;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * EtapaController implements the CRUD actions for Etapa model.
 */
class EtapaController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Etapa models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Etapa::find(),
            /*
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'numetapa' => SORT_DESC,
                ]
            ],
            */
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Etapa model.
     * @param int $numetapa Numetapa
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($numetapa)
    {
        return $this->render('view', [
            'model' => $this->findModel($numetapa),
        ]);
    }

    /**
     * Creates a new Etapa model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new Etapa();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'numetapa' => $model->numetapa]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Etapa model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $numetapa Numetapa
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($numetapa)
    {
        $model = $this->findModel($numetapa);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'numetapa' => $model->numetapa]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Etapa model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $numetapa Numetapa
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($numetapa)
    {
        $this->findModel($numetapa)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Etapa model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $numetapa Numetapa
     * @return Etapa the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($numetapa)
    {
        if (($model = Etapa::findOne(['numetapa' => $numetapa])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/LlevaController.php
<?php

namespace app\controllers;

use app\models\lleva;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * LlevaController implements the CRUD actions for lleva model.
 */
class LlevaController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all lleva models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => lleva::find(),
            /*
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'numetapa' => SORT_DESC,
                    'código' => SORT_DESC,
                ]
            ],
            */
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single lleva model.
     * @param int $numetapa Numetapa
     * @param string $código Código
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($numetapa, $código)
    {
        return $this->render('view', [
            'model' => $this->findModel($numetapa, $código),
        ]);
    }

    /**
     * Creates a new lleva model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new lleva();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'numetapa' => $model->numetapa, 'código' => $model->código]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing lleva model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $numetapa Numetapa
     * @param string $código Código
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($numetapa, $código)
    {
        $model = $this->findModel($numetapa, $código);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'numetapa' => $model->numetapa, 'código' => $model->código]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing lleva model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $numetapa Numetapa
     * @param string $código Código
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($numetapa, $código)
    {
        $this->findModel($numetapa, $código)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the lleva model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $numetapa Numetapa
     * @param string $código Código
     * @return lleva the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($numetapa, $código)
    {
        if (($model = lleva::findOne(['numetapa' => $numetapa, 'código' => $código])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use app\models\Ciclista;
use yii\data\ActiveDataProvider;
use yii\data\SqlDataProvider; 
use yii\db\Expression;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }
    
    public function actionConsulta1(){
        
     $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT eq.nomequipo, ROUND(AVG(c.edad)) as promedio_edad FROM equipo eq LEFT JOIN ciclista c ON c.nomequipo = eq.nomequipo GROUP BY eq.nomequipo',
        ]);
        
        return $this->render("grafico1",[
            "dataProvider"=>$dataProvider,
            "campos"=>["nomequipo", "promedio_edad"],
            "titulo"=>"Consulta 1 DAO",
            "enunciado"=>"Promedio de edad de los ciclistas en cada equipo",
            "sql"=>"SELECT eq.nomequipo, ROUND(AVG(c.edad)) as promedio_edad FROM equipo eq LEFT JOIN ciclista c ON c.nomequipo = eq.nomequipo GROUP BY eq.nomequipo"
        ]);          
    }
    
    public function actionConsulta2(){
        
        $dataProvider= new SqlDataProvider([
            'sql'=>'SELECT eq.nomequipo, COUNT(e.numetapa) as etapas_ganadas
            FROM equipo eq
            LEFT JOIN ciclista c ON eq.nomequipo = c.nomequipo
            LEFT JOIN lleva l ON c.dorsal = l.dorsal
            LEFT JOIN etapa e ON l.numetapa = e.numetapa
            WHERE e.dorsal = l.dorsal 
            GROUP BY eq.nomequipo',

        ]); 
        
           return $this->render("grafico2",[
            "dataProvider"=>$dataProvider,
            "campos"=>["nomequipo", "etapas_ganadas"],
            "titulo"=>"Consulta 2 DAO",
            "enunciado"=>"Número total de etapas ganadas por cada equipo",
            "sql"=> "SELECT eq.nomequipo, COUNT(e.numetapa) as etapas_ganadas
            FROM equipo eq
            LEFT JOIN ciclista c ON eq.nomequipo = c.nomequipo
            LEFT JOIN lleva l ON c.dorsal = l.dorsal
            LEFT JOIN etapa e ON l.numetapa = e.numetapa
            WHERE e.dorsal = l.dorsal 
            GROUP BY eq.nomequipo"
        ]);
    }
    
    
    public function actionConsulta3(){
        $dataProvider=new SqlDataProvider([
            'sql'=>'SELECT c.nombre, COUNT(e.numetapa) as total_etapas
            FROM ciclista c
            LEFT JOIN lleva l ON c.dorsal = l.dorsal
            LEFT JOIN etapa e ON l.numetapa = e.numetapa
            GROUP BY c.nombre',
        ]); 
        
        return $this->render("grafico3",[
            "dataProvider"=>$dataProvider,
            "campos"=>["nombre", "total_etapas"],
            "titulo"=>"Consulta 3 DAO",
            "enunciado"=>"Número total de etapas para cada ciclista",
            "sql"=> 'SELECT c.nombre, COUNT(e.numetapa) as total_etapas
            FROM ciclista c
            LEFT JOIN lleva l ON c.dorsal = l.dorsal
            LEFT JOIN etapa e ON l.numetapa = e.numetapa
            GROUP BY c.nombre'
        ]);
    }
    
    /* Para que se renderice la vista y no haga falta hacer un controller */
    public function actionNoticias(){
        return $this->render('noticias');
    }
    
   public function actionGraficos()
{
    // Utiliza SqlDataProvider para obtener resultados directamente de la consulta SQL
    $dataProvider = new SqlDataProvider([
        'sql' => 'SELECT nomequipo, ROUND(AVG(edad)) as promedio_edad FROM ciclista GROUP BY nomequipo',
    ]);

    $dataProvider2 = new SqlDataProvider([
        'sql' => 'SELECT eq.nomequipo, COUNT(e.numetapa) as etapas_ganadas
                  FROM equipo eq
                  LEFT JOIN ciclista c ON eq.nomequipo = c.nomequipo
                  LEFT JOIN lleva l ON c.dorsal = l.dorsal
                  LEFT JOIN etapa e ON l.numetapa = e.numetapa
                  WHERE e.dorsal = l.dorsal 
                  GROUP BY eq.nomequipo',
    ]);

    return $this->render('graficos', [
        'dataProvider' => $dataProvider,
        'dataProvider2' => $dataProvider2, // Asegúrate de pasar ambos DataProviders a la vista
    ]);
}
    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    /**
     * Displays contact page.
     *
     * @return Response|string
     */
    public function actionContact()
    {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
            'model' => $model,
        ]);
    }

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionNosotros()
    {
        return $this->render('nosotros');
    }
    public function actionListarCiclistas()
    {
    $ciclistas = Ciclista::find()
        ->select(['nombre'])
        ->groupBy(['nombre'])
        ->asArray()
        ->all();
    return $this->render('listarCiclistas', ['ciclistas' => $ciclistas]);
    }
    public function actionListarNombresCiclistas()
    {
    $nombresCiclistas = Ciclista::find()
        ->select(['nombre'])
        ->groupBy(['nombre'])
        ->asArray()
        ->all();

    // Asegúrate de pasar la variable a la vista
    return $this->renderPartial('listarNombresCiclistas', ['nombresCiclistas' => $nombresCiclistas]);
    }

     public function actionApuestas()
    {
        $resultados = Ciclista::find()
            ->select([
                'c.nombre',
                'COUNT(DISTINCT e.numetapa) as total_etapas', // Utiliza COUNT(DISTINCT) para evitar contar etapas duplicadas
                'COUNT(DISTINCT p.Nompuerto) as total_puertos', // Contar puertos distintos
            ])
            ->from(['c' => 'ciclista'])
            ->leftJoin('lleva l', 'c.dorsal = l.dorsal')
            ->leftJoin('etapa e', 'l.numetapa = e.numetapa')
            ->leftJoin('puerto p', 'e.dorsal = p.dorsal')
            ->groupBy(['c.nombre'])
            ->orderBy(['total_etapas' => SORT_DESC]) // Ordenar por total_etapas de mayor a menor
            ->asArray()
            ->all();

        // Simula los multiplicadores sin afectar la base de datos
        $baseMultiplicadorEtapas = 2;
        $baseMultiplicadorPuertos = 3; 

        $multiplicadores = [];

        foreach ($resultados as $resultado) {
            $totalEtapas = $resultado['total_etapas'];
            $totalPuertos = $resultado['total_puertos'];

            // Ajusta cómo calculas los multiplicadores en base a los totales de etapas y puertos
            $multiplicadores[$resultado['nombre']] = [
                'etapas' => $baseMultiplicadorEtapas / max(1, $totalEtapas),
                'puertos' => $baseMultiplicadorPuertos / max(1, $totalPuertos),
            ];
        }
         $nombresCiclistas = Ciclista::find()
        ->select(['nombre'])
        ->groupBy(['nombre'])
        ->asArray()
        ->all();

        return $this->render('apuestas', [
            'resultados' => $resultados,
            'multiplicadores' => $multiplicadores,
            'nombresCiclistas' => $nombresCiclistas,
        ]);
    }
}

views/layouts/main.php
<?php

/** @var yii\web\View $this */
/** @var string $content */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;
use yii\helpers\Url;
AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
    <head>
        <meta charset="<?= Yii::$app->charset ?>">
        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
        <?php $this->registerCsrfMetaTags() ?>
        <title><?= Html::encode($this->title) ?></title>
        <link href="https://fonts.googleapis.com/css2?family=Dosis&display=swap" rel="stylesheet">
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.0.0/css/all.min.css">
        <!-- Integración de Bootstrap CSS -->
        <?= Html::cssFile('https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css') ?>
        <link rel="stylesheet" href="<?=Url::to('@web/css/main.css')?>">
        <?php $this->head() ?>
            
    </head>
    <body class="d-flex flex-column h-100" style="overflow-x: hidden">
        <?php $this->beginBody() ?>

        <header>
            <?php
                NavBar::begin([
                    'brandLabel' => '<img src="' . Yii::getAlias('@web') . '/images/bike.png" alt="Logo" class="img-fluid" style="width:70px; height:70px">',
                    'brandUrl' => Yii::$app->homeUrl,
                    'options' => [
                        'class' => 'navbar navbar-expand-md navbar-dark bg-dark ',
                    ],
                ]);
                echo Nav::widget([
                'options' => ['class' => 'navbar-nav'],
                'items' => [
                    ['label' => 'Home', 'url' => ['/site/index']],
                    ['label' => 'Noticias', 'url' => ['site/noticias']],
                    ['label' => 'Apuestas', 'url' => ['site/apuestas']],
                    ['label' => 'Graficos', 'url' => ['site/graficos']],
                    ['label' => 'Sobre Nosotros', 'url' => ['/site/nosotros']],
                    [
                        'label' => 'Administración',
                        'items' => [
                            ['label' => 'Ciclistas', 'url' => ['/ciclista/index']],
                            ['label' => 'Equipos', 'url' => ['/equipo/index']],
                            ['label' => 'Etapas', 'url' => ['/etapa/index']],
                            ['label' => 'Llevan', 'url' => ['/lleva/index']],
                            ['label' => 'Maillots', 'url' => ['/maillot/index']],
                            ['label' => 'Puertos', 'url' => ['/puerto/index']],
                        ],
                    ],

                    Yii::$app->user->isGuest ? (
                        ['label' => 'Login', 'url' => ['/site/login']]
                    ) : (
                        '<li>'
                        . Html::beginForm(['/site/logout'], 'post', ['class' => 'form-inline'])
                        . Html::submitButton(
                            'Logout (' . Yii::$app->user->identity->username . ')',
                            ['class' => 'btn btn-link logout']
                        )
                        . Html::endForm()
                        . '</li>'
                    )
                ],
            ]);
            NavBar::end();
            ?>
        </header>

        <main role="main" class="flex-shrink-0" style="width:100vw; margin:0 ; padding: 0 ">
            <div class="container" style="margin:0; padding : 0; width: 100vw">
                <?= Breadcrumbs::widget([
                    'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
                ]) ?>
                <?= Alert::widget() ?>
                <?= $content ?>
            </div>
        </main>

     <footer class="text-light py-1">
    <div class="container">
        <div class="row align-items-center"> <!-- Alinea los elementos verticalmente -->
            <div class="col-md-3 text-center"> <!-- Centro el contenido y elimino la clase d-flex -->
                <img src="<?= Yii::getAlias('@web') ?>../images/bike.png" alt="Logo de la Marca" class="img-fluid rounded-circle" style="width: 160px;">
            </div>

            <div class="col-md-6 text-center"> <!-- Centro el contenido y elimino la clase d-flex -->
                <ul class="list-inline">
                    <li class="list-inline-item"><a href="#" target="_blank"><i style="color:#E9C46A;" class="fab fa-facebook-square fa-2x"></i></a></li>
                    <li class="list-inline-item"><a href="#" target="_blank"><i style="color:#E9C46A;" class="fab fa-twitter-square fa-2x"></i></a></li>
                    <li class="list-inline-item"><a href="#" target="_blank"><i style="color:#E9C46A;" class="fab fa-instagram-square fa-2x"></i></a></li>
                </ul>
            </div>

            <div class="col-md-3 text-md-left"> <!-- Alineo el texto a la izquierda en dispositivos de tamaño medio y superior -->
                <div class="d-flex flex-column align-items-center">
                    <div class="mb-2">
                        <i class="fas fa-map-marker-alt"></i> Dirección: Calle Principal, Ciudad
                    </div>
                    <div>
                        <i class="fas fa-phone-alt"></i> Teléfono: (123) 456-7890
                    </div>
                </div>
            </div>
        </div>
    </div>
        <div class="footer-text">
            Desarrollado con Grace Hopper.
    </footer>

        <!-- Integración de Bootstrap JS y jQuery -->
        <?= Html::jsFile('https://code.jquery.com/jquery-3.5.1.slim.min.js') ?>
        <?= Html::jsFile('https://cdn.jsdelivr.net/npm/@popperjs/core@2.0.8/dist/umd/popper.min.js') ?>
        <?= Html::jsFile('https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js') ?>

        <?php $this->endBody() ?>
    </body>
</html>
<?php $this->endPage() ?>